#pragma version(1)
#pragma rs java_package_name(cn.wps.show)

rs_allocation gIn;
rs_allocation gOut;
rs_script gScript;
uchar4 *deltaH;
uchar4 *deltaV;
uint32_t width;
uint32_t height;

float hw;
float hh;

static void setup() {
    hw = width / 2.0;
    hh = height / 2.0;

    float w = width;
    float h = height;
    for (int32_t i = 0; i < height; i++) {
        uchar4 color1 = *(const uchar4*)rsGetElementAt(gIn, 0, i);
        uchar4 color2 = *(const uchar4*)rsGetElementAt(gIn, width - 1, i);
        float da = (color2.a - color1.a) / w;
        float dr = (color2.r - color1.r) / w;
        float dg = (color2.g - color1.g) / w;
        float db = (color2.b - color1.b) / w;
        float a = color1.a;
        float r = color1.r;
        float g = color1.g;
        float b = color1.b;
        for (int j = 0; j < width; j++, a += da, r += dr, g += dg, b += db) {
            int index = i * width + j;
            deltaH[index].a = (int) a;
            deltaH[index].r = (int) r;
            deltaH[index].g = (int) g;
            deltaH[index].b = (int) b;
        }
    }

    for (int32_t i = 0; i < width; i++) {
        uchar4 color1 = *(const uchar4*)rsGetElementAt(gIn, i, 0);
        uchar4 color2 = *(const uchar4*)rsGetElementAt(gIn, i, height - 1);
        float da = (color2.a - color1.a) / h;
        float dr = (color2.r - color1.r) / h;
        float dg = (color2.g - color1.g) / h;
        float db = (color2.b - color1.b) / h;
        float a = color1.a;
        float r = color1.r;
        float g = color1.g;
        float b = color1.b;
        for (int j = 0; j < height; j++, a += da, r += dr, g += dg, b += db) {
            int index = i * height + j;
            deltaV[index].a = (int) a;
            deltaV[index].r = (int) r;
            deltaV[index].g = (int) g;
            deltaV[index].b = (int) b;
        }
    }
}

void filter() {
    setup();
    rsForEach(gScript, gIn, gOut);
}

void root(const uchar4 *in, uchar4 *out, const void *usrData, uint32_t x, uint32_t y) {
    float dist1 = fabs(x - hw) / hw;
    float dist2 = fabs(y - hh) / hh;
    float r1 = dist1 / (dist1 + dist2);
    float r2 = dist2 / (dist1 + dist2);
    // float r1 = 0;
    // float r2 = 1;

    uchar4 d1 = deltaH[y * width + x];
    uchar4 d2 = deltaV[x * height + y];

    (*out).a = (int) (d1.a * r1 + d2.a * r2);
    (*out).r = (int) (d1.r * r1 + d2.r * r2);
    (*out).g = (int) (d1.g * r1 + d2.g * r2);
    (*out).b = (int) (d1.b * r1 + d2.b * r2);
}