package cn.wps.moffice.writer.uitest_fw.aidl;

import cn.wps.moffice.writer.uitest_fw.aidl.IPlayCtrl;
import cn.wps.moffice.writer.uitest_fw.aidl.IRecordCtrl;
import cn.wps.moffice.writer.uitest_fw.aidl.Dialogs;
import cn.wps.moffice.writer.uitest_fw.aidl.IView;
import cn.wps.moffice.writer.uitest_fw.aidl.IPanel;
import cn.wps.moffice.writer.uitest_fw.aidl.IPanels;
import cn.wps.moffice.writer.uitest_fw.aidl.IPlayCallback;
import cn.wps.moffice.writer.uitest_fw.aidl.IRecordCallback;
import cn.wps.moffice.writer.uitest_fw.aidl.writer.IWriter;

interface ITestProcess {

	IPlayCtrl startPlay(String playerName, in List<String> args, IPlayCallback callback);
	
	boolean endPlay(String playerName);

	IRecordCtrl startRecord(String recorderName, in List<String> args, IRecordCallback callback);
	
	boolean endRecord(String recorderName);

	String getPath();
	
	boolean isFirstPageVisible();
	
	boolean isIOFinish();

	boolean isPlayIdle();
	
	void exit();
	
	void killProcess();
	
	///////////////////////////////////////////
	// API
	
	Dialogs getDialogs();
	
	// QuickAction,PopupWindow,AutoCompleteText
	IView getPopupView();
	
	IPanel getPanel(String panelName);
	
	IPanels getAllShowingPanels();
	
	boolean hideSoftkeyBoard();
	
	// 仅支持主文档
	boolean isSoftkeyBoardShowing();
	
	void keyEvent(int action, int keyCode, int metaState);
	
	boolean playAction(String actionName, String args);
	
	String getLastToast();
	
	// 屏幕坐标
	boolean scroll(float x, float y, float distanceX, float distanceY);
	
	// 屏幕坐标
	boolean scroll_onVelocity(float x, float y, float distanceX, float distanceY, float velocity);
	
	// 文档坐标
	boolean tap(float x, float y);
	
	// 文档坐标
	boolean doubleTap(float x, float y);
	
	// 文档坐标
	boolean longPress(float x, float y);
	
	////////////////////////////////////////////////
	
	IWriter getWriter();
}